﻿Imports System.Drawing.Drawing2D

Public Class Form1
  Dim panelface As New Bitmap(My.Resources.PumpGages)
  Dim gageface As New Bitmap(My.Resources.FaceWithoutNeedle)
  Dim needle As New Bitmap(My.Resources.needle)
  Private loadDone As Boolean

  Dim minutehand As NeedleType

  Dim clockfaceBmpRadius As Single  'Set to 1/2 the width of the bitmap read in for the clock face, assumes face is centered
  Dim scaleFactor As Single
  Dim xOffset As Single
  Dim yOffset As Single
  Dim rHour As Integer
  Dim rMinute As Single

  Dim rndValue As New Random

  Private Sub picClockDisplay_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picClockDisplay.Paint
    paintPicture(e.Graphics)    'Call the routine to draw the clock (there aren't many lines, we could have put the code here)
  End Sub

  Private Sub paintPicture(ByVal g As Graphics)
    Debug.Print(scaleFactor.ToString)
    g.ScaleTransform(scaleFactor, scaleFactor)                        'Scale by the size we want the clock to be
    g.DrawImage(panelface, 0, 0)

    Dim gc As GraphicsContainer = g.BeginContainer 'we don't want to disturb the Graphics object passed, so save its context
    g.TranslateTransform(192, 123)                            'Translate the 0,0 to where we want the center of the clock
    g.DrawImage(gageface, -85, -84)  'Draw the clockface bitmap, centered around 0,0
    minutehand.Render(g)                                              'Render the minute hand on top
    g.EndContainer(gc)                             'Restore the Graphics object to what it was when we came in.

    gc = g.BeginContainer
    g.TranslateTransform(443, 126)                            'Translate the 0,0 to where we want the center of the clock
    g.DrawImage(gageface, -85, -84)  'Draw the clockface bitmap, centered around 0,0
    minutehand.Render(g)
    g.EndContainer(gc)

    gc = g.BeginContainer
    g.TranslateTransform(65, 314)                            'Translate the 0,0 to where we want the center of the clock
    g.ScaleTransform(0.56, 0.56)
    g.DrawImage(gageface, -85, -84)  'Draw the clockface bitmap, centered around 0,0
    minutehand.Render(g)
    g.EndContainer(gc)

    gc = g.BeginContainer
    g.TranslateTransform(285, 315)                            'Translate the 0,0 to where we want the center of the clock
    g.ScaleTransform(0.56, 0.56)
    g.DrawImage(gageface, -85, -84)  'Draw the clockface bitmap, centered around 0,0
    minutehand.Render(g)
    g.EndContainer(gc)

    g.TranslateTransform(500, 315)                            'Translate the 0,0 to where we want the center of the clock
    g.ScaleTransform(0.56, 0.56)
    g.DrawImage(gageface, -85, -84)  'Draw the clockface bitmap, centered around 0,0
    minutehand.Render(g)

  End Sub

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'Dim tmpbmp As New Bitmap("..\..\MinuteHand_black_scaled.png")
    ' minutehand = New ClockHand(minutbmp, , False)  'minute hand with no shadow
    gageface.MakeTransparent()
    needle.MakeTransparent(Color.Magenta)                'The background color will be made transparent by this call
    minutehand = New NeedleType(needle, True, False)              'minute hand, transparent and with a shadow
    'tmpbmp.Dispose()                       'don't need it once we've created the object (the object makes a clone)

    'tmpbmp = New Bitmap("..\..\HourHand_black_scaled.png")  'Get the image for the hour hand
    'hourhand = New ClockHand(tmpbmp)                        'Create a Clockhand object with it
    'tmpbmp.Dispose()                                        'Dispose of the image

    'These values were derived from using the Edit form to move and rotate the hands
    'It would be nice to make a full edit that could save the object values automatically
    'But this was a quick example, not meant to be polished
    minutehand.hand_cx = 52   'The point in the hand image that the image spins around
    minutehand.hand_cy = 29
    ' minutehand.scaleFactor = scaleFactor '0.978 'minute hand was a bit big, going all the way to the rim after scaling in paint, so a bit here
    'hourhand.hand_cy = 112     'cx not set here because the default (center of the bitmap image) is what we would use anyway.
    'hourhand.shadow_dx = 3     'The shawdow defaults to 5,5 offset. We left that for the minute hand (which is higher), but
    'hourhand.shadow_dy = 3     'set the hour hand shadow closer to center, illusion of less height above face

    clockfaceBmpRadius = panelface.Width / 2   'So we know how far off in X and Y to draw the clockface centered around 0,0
    SetScaleFactor()                           'Calculate the over all scale of the clock based on drawing area
    loadDone = True
  End Sub

  Private Sub SetScaleFactor()
    xOffset = picClockDisplay.ClientSize.Width / 2   'Determine center of our drawing area
    yOffset = picClockDisplay.ClientSize.Height / 2
    'Scale up ( > 1.0) or down (< 1.0) or no scaling (1.0) depending on the shortest axis of our drawing area
    Dim bmpRadius As Single = Math.Max(panelface.Width, panelface.Height) / 2

    scaleFactor = Math.Min(xOffset, yOffset) / bmpRadius  'Our minimun axis radius / half width of our clockface bitmap 
  End Sub

  Private Sub picClockDisplay_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles picClockDisplay.Resize
    SetScaleFactor()              'When the drawing area is resized, we calculate the new scaling value
    If loadDone Then
      picClockDisplay.Invalidate()  'and redisplay the clock (at its new size)
    End If

  End Sub

  Private Sub lblRndTimeGenerator_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblRndTimeGenerator.Click
    rMinute = rndValue.Next(0, 60)                                            'generate a random minute value
    rHour = rndValue.Next(1, 13)                                              'generate a random hour value
    lblRndTimeGenerator.Text = String.Format("{0:0}:{1:00}", rHour, rMinute)  'Display the digital time in the label
    minutehand.angle = (rMinute * 6.0F) - 0.2                                    'Calculate angle of minute hand (6 degrees per minute)
    '    hourhand.angle = rHour * 30.0F + rMinute * 0.5F                           'Calculate angle of hour (30 degrees per hour + .5 per minute)
    picClockDisplay.Invalidate()                                              'Redraw the clock
  End Sub

  Private Sub lblRndTimeGenerator_MouseMove(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles lblRndTimeGenerator.MouseMove
    Static lpos As Point
    If e.Button = Windows.Forms.MouseButtons.Left Then
      rMinute += (e.X - lpos.X) / 10
      If rMinute > 60 Then rMinute -= 60
      If rMinute < 0 Then rMinute += 60
      minutehand.angle = (rMinute * 6.0F) - 0.2                                    'Calculate angle of minute hand (6 degrees per minute)
      picClockDisplay.Refresh()                                              'Redraw the clock
    End If
    lpos = e.Location
  End Sub

  Private Sub RadioButton_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rbMinuteHand.MouseUp, rbHourHand.MouseUp
    'This routine and the Edit form would be removed from a working project.
    'This just allows manually manipulating the hands, reposition where the hand images are relative to the center, scaling, etc.
    If rbMinuteHand.Checked = True Then
      EditForm.HandObject = minutehand
    Else
      '      EditForm.HandObject = hourhand
    End If
    EditForm.Show()
    EditForm.ReDisplayValues()
  End Sub

  Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
    If CheckBox1.Checked Then
      Timer1.Interval = 250
      Timer1.Start()
    Else
      Timer1.Stop()
    End If
  End Sub

  Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
    Dim d As Date = Now

    rMinute = d.Minute
    rHour = d.Hour
    lblRndTimeGenerator.Text = d.ToString("T")
    minutehand.angle = (rMinute * 6.0F + d.Second * 0.1 + d.Millisecond * 0.0001) - 0.2   'Calculate angle of minute hand (6 degrees per minute)
    '    hourhand.angle = rHour * 30.0F + rMinute * 0.5F + d.Second * 0.0083                   'Calculate angle of hour (30 degrees per hour + .5 per minute)
    picClockDisplay.Invalidate()                                                          'Redraw the clock
  End Sub


End Class
